/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import com.rjconsultores.ventaboletos.entidad.Constante;
import com.rjconsultores.ventaboletos.service.ConstanteService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import java.util.Calendar;
import java.util.List;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Radio;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("editarConfiguracionGeneralController")
@Scope("prototype")
public class EditarConfiguracionGeneralController extends MyGenericForwardComposer {

    @Autowired
    private ConstanteService constanteService;
    private Constante constante;
    private MyListbox constanteList;
    private static Logger log = Logger.getLogger(EditarConfiguracionGeneralController.class);
    private Textbox txtNome;
    private Textbox descconstante;
    private Textbox valorconstante;
    private Textbox indtipoconstante;
    private Radio radMantenimientoUsuarioSi;
    private Radio radMantenimientoUsuarioNo;
    private Button btnApagar;
    private Button btnSalvar;

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Radio getRadMantenimientoUsuarioNo() {
        return radMantenimientoUsuarioNo;
    }

    public void setRadMantenimientoUsuarioNo(Radio radMantenimientoUsuarioNo) {
        this.radMantenimientoUsuarioNo = radMantenimientoUsuarioNo;
    }

    public Radio getRadMantenimientoUsuarioSi() {
        return radMantenimientoUsuarioSi;
    }

    public void setRadMantenimientoUsuarioSi(Radio radMantenimientoUsuarioSi) {
        this.radMantenimientoUsuarioSi = radMantenimientoUsuarioSi;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        constante = (Constante) Executions.getCurrent().getArg().get("constante");
        constanteList = (MyListbox) Executions.getCurrent().getArg().get("constanteList");

        radMantenimientoUsuarioSi.setChecked(true);
        radMantenimientoUsuarioNo.setChecked(false);

        if (constante.getConstanteId() != null) {
            if (constante.getIndmantenimientousuario() == Boolean.FALSE) {
                radMantenimientoUsuarioSi.setChecked(false);
                radMantenimientoUsuarioNo.setChecked(true);

                //Se mantenimiento es NO, não se pode fazer nada na tela.
                valorconstante.setDisabled(Boolean.TRUE);

                radMantenimientoUsuarioSi.setDisabled(Boolean.TRUE);
                radMantenimientoUsuarioNo.setDisabled(Boolean.TRUE);

                btnApagar.setVisible(Boolean.FALSE);
                btnSalvar.setVisible(Boolean.FALSE);

                Messagebox.show(
                        Labels.getLabel("MSG.noEditabled"),
                        Labels.getLabel("editarConfiguracionGeneralController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            }

            txtNome.setDisabled(Boolean.TRUE);
            descconstante.setDisabled(Boolean.TRUE);
            indtipoconstante.setDisabled(Boolean.TRUE);
        }

        if (constante.getConstanteId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        txtNome.focus();

    }

    public void onClick$btnSalvar(Event ev) {
        txtNome.getValue();
        valorconstante.getValue();
        //indtipoconstante.getValue();

        try {
            constante.setActivo(true);
            constante.setFecmodif(Calendar.getInstance().getTime());
            constante.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            constante.setIndmantenimientousuario(radMantenimientoUsuarioSi.isChecked() ? Boolean.TRUE : Boolean.FALSE);

            if (constante.getConstanteId() == null) {
                List<Constante> lsConstante = constanteService.buscar(constante.getNombconstante());

                if (!lsConstante.isEmpty()) {
                    Messagebox.show(
                            Labels.getLabel("MSG.Registro.Existe"),
                            Labels.getLabel("editarConfiguracionGeneralController.window.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                } else {
                    constanteService.suscribir(constante);
                    constanteList.addItem(constante);

                    Messagebox.show(
                            Labels.getLabel("editarConfiguracionGeneralController.MSG.suscribirOK"),
                            Labels.getLabel("editarConfiguracionGeneralController.window.title"),
                            Messagebox.OK, Messagebox.INFORMATION);

                    closeWindow();
                }
            } else {
                constanteService.actualizacion(constante);
                constanteList.updateItem(constante);

                Messagebox.show(
                        Labels.getLabel("editarConfiguracionGeneralController.MSG.suscribirOK"),
                        Labels.getLabel("editarConfiguracionGeneralController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarConfiguracionGeneralController.MSG.borrarPergunta"),
                    Labels.getLabel("editarConfiguracionGeneralController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                constanteService.borrar(constante);

                Messagebox.show(
                        Labels.getLabel("editarConfiguracionGeneralController.MSG.borrarOK"),
                        Labels.getLabel("editarConfiguracionGeneralController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                constanteList.removeItem(constante);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public Constante getConstante() {
        return constante;
    }

    public void setConstante(Constante constante) {
        this.constante = constante;
    }

    public MyListbox getConstanteList() {
        return constanteList;
    }

    public void setConstanteList(MyListbox constanteList) {
        this.constanteList = constanteList;
    }

    public ConstanteService getConstanteService() {
        return constanteService;
    }

    public void setConstanteService(ConstanteService constanteService) {
        this.constanteService = constanteService;
    }
}
